/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_GRAMMAR_H_INCLUDED
# define YY_YY_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    ANY = 258,                     /* ANY  */
    IP = 259,                      /* IP  */
    TUNIP = 260,                   /* TUNIP  */
    IF = 261,                      /* IF  */
    MAC = 262,                     /* MAC  */
    MPLS = 263,                    /* MPLS  */
    TOS = 264,                     /* TOS  */
    DIR = 265,                     /* DIR  */
    FLAGS = 266,                   /* FLAGS  */
    TUN = 267,                     /* TUN  */
    PROTO = 268,                   /* PROTO  */
    MASK = 269,                    /* MASK  */
    NET = 270,                     /* NET  */
    PORT = 271,                    /* PORT  */
    FWDSTAT = 272,                 /* FWDSTAT  */
    IN = 273,                      /* IN  */
    OUT = 274,                     /* OUT  */
    SRC = 275,                     /* SRC  */
    DST = 276,                     /* DST  */
    EQ = 277,                      /* EQ  */
    LT = 278,                      /* LT  */
    GT = 279,                      /* GT  */
    LE = 280,                      /* LE  */
    GE = 281,                      /* GE  */
    PREV = 282,                    /* PREV  */
    NEXT = 283,                    /* NEXT  */
    IDENT = 284,                   /* IDENT  */
    ENGINE_TYPE = 285,             /* ENGINE_TYPE  */
    ENGINE_ID = 286,               /* ENGINE_ID  */
    EXPORTER = 287,                /* EXPORTER  */
    AS = 288,                      /* AS  */
    GEO = 289,                     /* GEO  */
    PACKETS = 290,                 /* PACKETS  */
    BYTES = 291,                   /* BYTES  */
    FLOWS = 292,                   /* FLOWS  */
    LABEL = 293,                   /* LABEL  */
    NFVERSION = 294,               /* NFVERSION  */
    COUNT = 295,                   /* COUNT  */
    PPS = 296,                     /* PPS  */
    BPS = 297,                     /* BPS  */
    BPP = 298,                     /* BPP  */
    DURATION = 299,                /* DURATION  */
    NOT = 300,                     /* NOT  */
    IPV4 = 301,                    /* IPV4  */
    IPV6 = 302,                    /* IPV6  */
    BGPNEXTHOP = 303,              /* BGPNEXTHOP  */
    ROUTER = 304,                  /* ROUTER  */
    VLAN = 305,                    /* VLAN  */
    CLIENT = 306,                  /* CLIENT  */
    SERVER = 307,                  /* SERVER  */
    APP = 308,                     /* APP  */
    LATENCY = 309,                 /* LATENCY  */
    SYSID = 310,                   /* SYSID  */
    ASA = 311,                     /* ASA  */
    DENIED = 312,                  /* DENIED  */
    XEVENT = 313,                  /* XEVENT  */
    XNET = 314,                    /* XNET  */
    XPORT = 315,                   /* XPORT  */
    INGRESS = 316,                 /* INGRESS  */
    EGRESS = 317,                  /* EGRESS  */
    ACL = 318,                     /* ACL  */
    ACE = 319,                     /* ACE  */
    XACE = 320,                    /* XACE  */
    NAT = 321,                     /* NAT  */
    ADD = 322,                     /* ADD  */
    EVENT = 323,                   /* EVENT  */
    VRF = 324,                     /* VRF  */
    NPORT = 325,                   /* NPORT  */
    NIP = 326,                     /* NIP  */
    PBLOCK = 327,                  /* PBLOCK  */
    START = 328,                   /* START  */
    END = 329,                     /* END  */
    STEP = 330,                    /* STEP  */
    SIZE = 331,                    /* SIZE  */
    PAYLOAD = 332,                 /* PAYLOAD  */
    CONTENT = 333,                 /* CONTENT  */
    REGEX = 334,                   /* REGEX  */
    JA3 = 335,                     /* JA3  */
    OBSERVATION = 336,             /* OBSERVATION  */
    DOMAIN = 337,                  /* DOMAIN  */
    POINT = 338,                   /* POINT  */
    ID = 339,                      /* ID  */
    PF = 340,                      /* PF  */
    PFACTION = 341,                /* PFACTION  */
    PFREASON = 342,                /* PFREASON  */
    RULE = 343,                    /* RULE  */
    INTERFACE = 344,               /* INTERFACE  */
    STRING = 345,                  /* STRING  */
    WORD = 346,                    /* WORD  */
    REASON = 347,                  /* REASON  */
    NUMBER = 348,                  /* NUMBER  */
    PORTNUM = 349,                 /* PORTNUM  */
    ICMP_TYPE = 350,               /* ICMP_TYPE  */
    ICMP_CODE = 351,               /* ICMP_CODE  */
    OR = 352,                      /* OR  */
    AND = 353,                     /* AND  */
    NEGATE = 354                   /* NEGATE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define ANY 258
#define IP 259
#define TUNIP 260
#define IF 261
#define MAC 262
#define MPLS 263
#define TOS 264
#define DIR 265
#define FLAGS 266
#define TUN 267
#define PROTO 268
#define MASK 269
#define NET 270
#define PORT 271
#define FWDSTAT 272
#define IN 273
#define OUT 274
#define SRC 275
#define DST 276
#define EQ 277
#define LT 278
#define GT 279
#define LE 280
#define GE 281
#define PREV 282
#define NEXT 283
#define IDENT 284
#define ENGINE_TYPE 285
#define ENGINE_ID 286
#define EXPORTER 287
#define AS 288
#define GEO 289
#define PACKETS 290
#define BYTES 291
#define FLOWS 292
#define LABEL 293
#define NFVERSION 294
#define COUNT 295
#define PPS 296
#define BPS 297
#define BPP 298
#define DURATION 299
#define NOT 300
#define IPV4 301
#define IPV6 302
#define BGPNEXTHOP 303
#define ROUTER 304
#define VLAN 305
#define CLIENT 306
#define SERVER 307
#define APP 308
#define LATENCY 309
#define SYSID 310
#define ASA 311
#define DENIED 312
#define XEVENT 313
#define XNET 314
#define XPORT 315
#define INGRESS 316
#define EGRESS 317
#define ACL 318
#define ACE 319
#define XACE 320
#define NAT 321
#define ADD 322
#define EVENT 323
#define VRF 324
#define NPORT 325
#define NIP 326
#define PBLOCK 327
#define START 328
#define END 329
#define STEP 330
#define SIZE 331
#define PAYLOAD 332
#define CONTENT 333
#define REGEX 334
#define JA3 335
#define OBSERVATION 336
#define DOMAIN 337
#define POINT 338
#define ID 339
#define PF 340
#define PFACTION 341
#define PFREASON 342
#define RULE 343
#define INTERFACE 344
#define STRING 345
#define WORD 346
#define REASON 347
#define NUMBER 348
#define PORTNUM 349
#define ICMP_TYPE 350
#define ICMP_CODE 351
#define OR 352
#define AND 353
#define NEGATE 354

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 132 "grammar.y"

	uint64_t		value;
	char			*s;
	FilterParam_t	param;
	void			*list;

#line 272 "grammar.h"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_GRAMMAR_H_INCLUDED  */
